> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.hellosign.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.hellosign.com/_mcp/server.

# Edit Signature Request

PUT https://api.hellosign.com/v3/signature_request/edit/{signature_request_id}
Content-Type: application/json

Edits and sends a SignatureRequest with the submitted documents. If `form_fields_per_document` is not specified, a signature page will be affixed where all signers will be required to add their signature, signifying their agreement to all contained documents.

**NOTE:** Edit and resend *will* deduct your signature request quota.

Reference: https://developers.hellosign.com/api/signature-request/edit

## Authentication

- `Authorization` header (basic auth, required) — Your API key can be used to make calls to the Dropbox Sign API. See [Authentication](/api/reference/authentication) for more information. ✅ Supported by Try it console (calls sent in `test_mode` only).
- `Authorization` header (bearer token, required) — You can use an Access Token issued through an OAuth flow to send calls to the Dropbox Sign API from your app. The access scopes required by this endpoint are listed in the gray box above. See [Authentication](/api/reference/authentication) for more information. ❌ **Not supported** by Try it console.

## Request

### Path parameters

- `signature_request_id` (string, required) — The id of the SignatureRequest to edit.

### Body (application/json)

- `files` (list of string, optional) — Use `files[]` to indicate the uploaded file(s) to send for signature. This endpoint requires either **files** or **file_urls[]**, but not both.
- `file_urls` (list of string, optional) — Use `file_urls[]` to have Dropbox Sign download the file(s) to send for signature. This endpoint requires either **files** or **file_urls[]**, but not both.
- `signers` (list of object, optional) — Add Signers to your Signature Request. This endpoint requires either **signers** or **grouped_signers**, but not both.
  - `name` (string, required) — The name of the signer.
  - `email_address` (string, required) — The email address of the signer.
  - `order` (integer, optional, nullable) — The order the signer is required to sign in.
  - `pin` (string, optional) — The 4- to 12-character access code that will secure this signer's signature page.
  - `sms_phone_number` (string, optional) — An E.164 formatted phone number. By using the feature, you agree you are responsible for obtaining a signer's consent to receive text messages from Dropbox Sign related to this signature request and confirm you have obtained such consent from all signers prior to enabling SMS delivery for this signature request. [Learn more](https://faq.hellosign.com/hc/en-us/articles/15815316468877-Dropbox-Sign-SMS-tools-add-on). **NOTE:** Not available in test mode and requires a Standard plan or higher.
  - `sms_phone_number_type` (enum, optional) — Specifies the feature used with the `sms_phone_number`. Default `authentication`. If `authentication`, signer is sent a verification code via SMS that is required to access the document. If `delivery`, a link to complete the signature request is delivered via SMS (_and_ email).
    - Allowed values: `authentication`, `delivery`
- `grouped_signers` (list of object, optional) — Add Grouped Signers to your Signature Request. This endpoint requires either **signers** or **grouped_signers**, but not both.
  - `group` (string, required) — The name of the group.
  - `signers` (list of object, required) — Signers belonging to this Group. **NOTE:** Only `name`, `email_address`, and `pin` are available to Grouped Signers. We will ignore all other properties, even though they are listed below.
    - `name` (string, required) — The name of the signer.
    - `email_address` (string, required) — The email address of the signer.
    - `order` (integer, optional, nullable) — The order the signer is required to sign in.
    - `pin` (string, optional) — The 4- to 12-character access code that will secure this signer's signature page.
    - `sms_phone_number` (string, optional) — An E.164 formatted phone number. By using the feature, you agree you are responsible for obtaining a signer's consent to receive text messages from Dropbox Sign related to this signature request and confirm you have obtained such consent from all signers prior to enabling SMS delivery for this signature request. [Learn more](https://faq.hellosign.com/hc/en-us/articles/15815316468877-Dropbox-Sign-SMS-tools-add-on). **NOTE:** Not available in test mode and requires a Standard plan or higher.
    - `sms_phone_number_type` (enum, optional) — Specifies the feature used with the `sms_phone_number`. Default `authentication`. If `authentication`, signer is sent a verification code via SMS that is required to access the document. If `delivery`, a link to complete the signature request is delivered via SMS (_and_ email).
      - Allowed values: `authentication`, `delivery`
  - `order` (integer, optional, nullable) — The order the group is required to sign in. Use this instead of Signer-level `order`.
- `allow_decline` (boolean, optional, default: false) — Allows signers to decline to sign a document if `true`. Defaults to `false`.
- `allow_reassign` (boolean, optional, default: false) — Allows signers to reassign their signature requests to other signers if set to `true`. Defaults to `false`. **NOTE:** Only available for Premium plan and higher.
- `attachments` (list of object, optional) — A list describing the attachments
  - `name` (string, required) — The name of attachment.
  - `signer_index` (integer, required) — The signer's index in the `signers` parameter (0-based indexing). **NOTE:** Only one signer can be assigned per attachment.
  - `instructions` (string, optional) — The instructions for uploading the attachment.
  - `required` (boolean, optional, default: false) — Determines if the attachment must be uploaded.
- `cc_email_addresses` (list of string, optional) — The email addresses that should be CCed.
- `client_id` (string, optional) — The client id of the API App you want to associate with this request. Used to apply the branding and callback url defined for the app.
- `custom_fields` (list of object, optional) — When used together with merge fields, `custom_fields` allows users to add pre-filled data to their signature requests. Pre-filled data can be used with "send-once" signature requests by adding merge fields with `form_fields_per_document` or [Text Tags](https://app.hellosign.com/api/textTagsWalkthrough#TextTagIntro) while passing values back with `custom_fields` together in one API call. For using pre-filled on repeatable signature requests, merge fields are added to templates in the Dropbox Sign UI or by calling [/template/create_embedded_draft](/api/reference/operation/templateCreateEmbeddedDraft) and then passing `custom_fields` on subsequent signature requests referencing that template.
  - `name` (string, required) — The name of a custom field. When working with pre-filled data, the custom field's name must have a matching merge field name or the field will remain empty on the document during signing.
  - `editor` (string, optional) — Used to create editable merge fields. When the value matches a role passed in with `signers`, that role can edit the data that was pre-filled to that field. This field is optional, but required when this custom field object is set to `required = true`. **NOTE:** Editable merge fields are only supported for single signer requests (or the first signer in ordered signature requests). If used when there are multiple signers in an unordered signature request, the editor value is ignored and the field won't be editable.
  - `required` (boolean, optional, default: false) — Used to set an editable merge field when working with pre-filled data. When `true`, the custom field must specify a signer role in `editor`.
  - `value` (string, optional) — The string that resolves (aka "pre-fills") to the merge field on the final document(s) used for signing.
- `field_options` (object, optional) — This allows the requester to specify field options for a signature request.
  - `date_format` (enum, required) — Allows requester to specify the date format (see list of allowed [formats](/api/reference/constants/#date-formats)) **NOTE:** Only available for Premium and higher.
    - Allowed values: `MM / DD / YYYY`, `MM - DD - YYYY`, `DD / MM / YYYY`, `DD - MM - YYYY`, `YYYY / MM / DD`, `YYYY - MM - DD`
- `form_field_groups` (list of object, optional) — Group information for fields defined in `form_fields_per_document`. String-indexed JSON array with `group_label` and `requirement` keys. `form_fields_per_document` must contain fields referencing a group defined in `form_field_groups`.
  - `group_id` (string, required) — ID of group. Use this to reference a specific group from the `group` value in `form_fields_per_document`.
  - `group_label` (string, required) — Name of the group
  - `requirement` (string, required) — Examples: `require_0-1` `require_1` `require_1-ormore` - Check out the list of [acceptable `requirement` checkbox type values](/api/reference/constants/#checkbox-field-grouping). - Check out the list of [acceptable `requirement` radio type fields](/api/reference/constants/#radio-field-grouping). - Radio groups require **at least** two fields per group.
- `form_field_rules` (list of object, optional) — Conditional Logic rules for fields defined in `form_fields_per_document`.
  - `id` (string, required) — Must be unique across all defined rules.
  - `trigger_operator` (string, required, default: AND) — Currently only `AND` is supported. Support for `OR` is being worked on.
  - `triggers` (list of object, required) — An array of trigger definitions, the "if this" part of "**if this**, then that". Currently only a single trigger per rule is allowed.
    - `id` (string, required) — Must reference the `api_id` of an existing field defined within `form_fields_per_document`. Trigger and action fields and groups must belong to the same signer.
    - `operator` (enum, required) — Different field types allow different `operator` values: - Field type of **text**: - **is**: exact match - **not**: not exact match - **match**: regular expression, without /. Example: - OK `[a-zA-Z0-9]` - Not OK `/[a-zA-Z0-9]/` - Field type of **dropdown**: - **is**: exact match, single value - **not**: not exact match, single value - **any**: exact match, array of values. - **none**: not exact match, array of values. - Field type of **checkbox**: - **is**: exact match, single value - **not**: not exact match, single value - Field type of **radio**: - **is**: exact match, single value - **not**: not exact match, single value
      - Allowed values: `any`, `is`, `match`, `none`, `not`
    - `value` (string, optional) — **value** or **values** is required, but not both. The value to match against **operator**. - When **operator** is one of the following, **value** must be `String`: - `is` - `not` - `match` Otherwise, - **checkbox**: When **type** of trigger is **checkbox**, **value** must be `0` or `1` - **radio**: When **type** of trigger is **radio**, **value** must be `1`
    - `values` (list of string, optional) — **values** or **value** is required, but not both. The values to match against **operator** when it is one of the following: - `any` - `none`
  - `actions` (list of object, required) — An array of action definitions, the "then that" part of "if this, **then that**". Any number of actions may be attached to a single rule.
    - `hidden` (boolean, required) — `true` to hide the target field when rule is satisfied, otherwise `false`.
    - `type` (enum, required)
      - Allowed values: `change-field-visibility`, `change-group-visibility`
    - `field_id` (string, optional) — **field_id** or **group_id** is required, but not both. Must reference the `api_id` of an existing field defined within `form_fields_per_document`. Cannot use with `group_id`. Trigger and action fields must belong to the same signer.
    - `group_id` (string, optional) — **group_id** or **field_id** is required, but not both. Must reference the ID of an existing group defined within `form_field_groups`. Cannot use with `field_id`. Trigger and action fields and groups must belong to the same signer.
- `form_fields_per_document` (list of object, optional) — The fields that should appear on the document, expressed as an array of objects. (For more details you can read about it here: [Using Form Fields per Document](/docs/openapi/form-fields-per-document).) **NOTE:** Fields like **text**, **dropdown**, **checkbox**, **radio**, and **hyperlink** have additional required and optional parameters. Check out the list of [additional parameters](/api/reference/constants/#form-fields-per-document) for these field types. * Text Field use `SubFormFieldsPerDocumentText` * Dropdown Field use `SubFormFieldsPerDocumentDropdown` * Hyperlink Field use `SubFormFieldsPerDocumentHyperlink` * Checkbox Field use `SubFormFieldsPerDocumentCheckbox` * Radio Field use `SubFormFieldsPerDocumentRadio` * Signature Field use `SubFormFieldsPerDocumentSignature` * Date Signed Field use `SubFormFieldsPerDocumentDateSigned` * Initials Field use `SubFormFieldsPerDocumentInitials` * Text Merge Field use `SubFormFieldsPerDocumentTextMerge` * Checkbox Merge Field use `SubFormFieldsPerDocumentCheckboxMerge`
  - `type`: `text` (text)
    - `document_index` (integer, required) — Represents the integer index of the `file` or `file_url` document the field should be attached to.
    - `api_id` (string, required) — An identifier for the field that is unique across all documents in the request.
    - `height` (integer, required) — Size of the field in pixels.
    - `required` (boolean, required) — Whether this field is required.
    - `signer` (string, required) — Signer index identified by the offset in the signers parameter (0-based indexing), indicating which signer should fill out the field. **NOTE:** To set the value of the field as the preparer you must set this to `me_now` **NOTE:** If type is `text-merge` or `checkbox-merge`, you must set this to sender in order to use pre-filled data.
    - `width` (integer, required) — Size of the field in pixels.
    - `x` (integer, required) — Location coordinates of the field in pixels.
    - `y` (integer, required) — Location coordinates of the field in pixels.
    - `name` (string, optional) — Display name for the field.
    - `page` (integer, optional, nullable) — Page in the document where the field should be placed (requires documents be PDF files). - When the page number parameter is supplied, the API will use the new coordinate system. - Check out the differences between both [coordinate systems](https://faq.hellosign.com/hc/en-us/articles/217115577) and how to use them.
  - `type`: `dropdown` (dropdown)
    - `document_index` (integer, required) — Represents the integer index of the `file` or `file_url` document the field should be attached to.
    - `api_id` (string, required) — An identifier for the field that is unique across all documents in the request.
    - `height` (integer, required) — Size of the field in pixels.
    - `required` (boolean, required) — Whether this field is required.
    - `signer` (string, required) — Signer index identified by the offset in the signers parameter (0-based indexing), indicating which signer should fill out the field. **NOTE:** To set the value of the field as the preparer you must set this to `me_now` **NOTE:** If type is `text-merge` or `checkbox-merge`, you must set this to sender in order to use pre-filled data.
    - `width` (integer, required) — Size of the field in pixels.
    - `x` (integer, required) — Location coordinates of the field in pixels.
    - `y` (integer, required) — Location coordinates of the field in pixels.
    - `name` (string, optional) — Display name for the field.
    - `page` (integer, optional, nullable) — Page in the document where the field should be placed (requires documents be PDF files). - When the page number parameter is supplied, the API will use the new coordinate system. - Check out the differences between both [coordinate systems](https://faq.hellosign.com/hc/en-us/articles/217115577) and how to use them.
  - `type`: `hyperlink` (hyperlink)
    - `document_index` (integer, required) — Represents the integer index of the `file` or `file_url` document the field should be attached to.
    - `api_id` (string, required) — An identifier for the field that is unique across all documents in the request.
    - `height` (integer, required) — Size of the field in pixels.
    - `required` (boolean, required) — Whether this field is required.
    - `signer` (string, required) — Signer index identified by the offset in the signers parameter (0-based indexing), indicating which signer should fill out the field. **NOTE:** To set the value of the field as the preparer you must set this to `me_now` **NOTE:** If type is `text-merge` or `checkbox-merge`, you must set this to sender in order to use pre-filled data.
    - `width` (integer, required) — Size of the field in pixels.
    - `x` (integer, required) — Location coordinates of the field in pixels.
    - `y` (integer, required) — Location coordinates of the field in pixels.
    - `name` (string, optional) — Display name for the field.
    - `page` (integer, optional, nullable) — Page in the document where the field should be placed (requires documents be PDF files). - When the page number parameter is supplied, the API will use the new coordinate system. - Check out the differences between both [coordinate systems](https://faq.hellosign.com/hc/en-us/articles/217115577) and how to use them.
  - `type`: `checkbox` (checkbox)
    - `document_index` (integer, required) — Represents the integer index of the `file` or `file_url` document the field should be attached to.
    - `api_id` (string, required) — An identifier for the field that is unique across all documents in the request.
    - `height` (integer, required) — Size of the field in pixels.
    - `required` (boolean, required) — Whether this field is required.
    - `signer` (string, required) — Signer index identified by the offset in the signers parameter (0-based indexing), indicating which signer should fill out the field. **NOTE:** To set the value of the field as the preparer you must set this to `me_now` **NOTE:** If type is `text-merge` or `checkbox-merge`, you must set this to sender in order to use pre-filled data.
    - `width` (integer, required) — Size of the field in pixels.
    - `x` (integer, required) — Location coordinates of the field in pixels.
    - `y` (integer, required) — Location coordinates of the field in pixels.
    - `name` (string, optional) — Display name for the field.
    - `page` (integer, optional, nullable) — Page in the document where the field should be placed (requires documents be PDF files). - When the page number parameter is supplied, the API will use the new coordinate system. - Check out the differences between both [coordinate systems](https://faq.hellosign.com/hc/en-us/articles/217115577) and how to use them.
  - `type`: `radio` (radio)
    - `document_index` (integer, required) — Represents the integer index of the `file` or `file_url` document the field should be attached to.
    - `api_id` (string, required) — An identifier for the field that is unique across all documents in the request.
    - `height` (integer, required) — Size of the field in pixels.
    - `required` (boolean, required) — Whether this field is required.
    - `signer` (string, required) — Signer index identified by the offset in the signers parameter (0-based indexing), indicating which signer should fill out the field. **NOTE:** To set the value of the field as the preparer you must set this to `me_now` **NOTE:** If type is `text-merge` or `checkbox-merge`, you must set this to sender in order to use pre-filled data.
    - `width` (integer, required) — Size of the field in pixels.
    - `x` (integer, required) — Location coordinates of the field in pixels.
    - `y` (integer, required) — Location coordinates of the field in pixels.
    - `name` (string, optional) — Display name for the field.
    - `page` (integer, optional, nullable) — Page in the document where the field should be placed (requires documents be PDF files). - When the page number parameter is supplied, the API will use the new coordinate system. - Check out the differences between both [coordinate systems](https://faq.hellosign.com/hc/en-us/articles/217115577) and how to use them.
  - `type`: `signature` (signature)
    - `document_index` (integer, required) — Represents the integer index of the `file` or `file_url` document the field should be attached to.
    - `api_id` (string, required) — An identifier for the field that is unique across all documents in the request.
    - `height` (integer, required) — Size of the field in pixels.
    - `required` (boolean, required) — Whether this field is required.
    - `signer` (string, required) — Signer index identified by the offset in the signers parameter (0-based indexing), indicating which signer should fill out the field. **NOTE:** To set the value of the field as the preparer you must set this to `me_now` **NOTE:** If type is `text-merge` or `checkbox-merge`, you must set this to sender in order to use pre-filled data.
    - `width` (integer, required) — Size of the field in pixels.
    - `x` (integer, required) — Location coordinates of the field in pixels.
    - `y` (integer, required) — Location coordinates of the field in pixels.
    - `name` (string, optional) — Display name for the field.
    - `page` (integer, optional, nullable) — Page in the document where the field should be placed (requires documents be PDF files). - When the page number parameter is supplied, the API will use the new coordinate system. - Check out the differences between both [coordinate systems](https://faq.hellosign.com/hc/en-us/articles/217115577) and how to use them.
  - `type`: `date_signed` (date_signed)
    - `document_index` (integer, required) — Represents the integer index of the `file` or `file_url` document the field should be attached to.
    - `api_id` (string, required) — An identifier for the field that is unique across all documents in the request.
    - `height` (integer, required) — Size of the field in pixels.
    - `required` (boolean, required) — Whether this field is required.
    - `signer` (string, required) — Signer index identified by the offset in the signers parameter (0-based indexing), indicating which signer should fill out the field. **NOTE:** To set the value of the field as the preparer you must set this to `me_now` **NOTE:** If type is `text-merge` or `checkbox-merge`, you must set this to sender in order to use pre-filled data.
    - `width` (integer, required) — Size of the field in pixels.
    - `x` (integer, required) — Location coordinates of the field in pixels.
    - `y` (integer, required) — Location coordinates of the field in pixels.
    - `name` (string, optional) — Display name for the field.
    - `page` (integer, optional, nullable) — Page in the document where the field should be placed (requires documents be PDF files). - When the page number parameter is supplied, the API will use the new coordinate system. - Check out the differences between both [coordinate systems](https://faq.hellosign.com/hc/en-us/articles/217115577) and how to use them.
  - `type`: `initials` (initials)
    - `document_index` (integer, required) — Represents the integer index of the `file` or `file_url` document the field should be attached to.
    - `api_id` (string, required) — An identifier for the field that is unique across all documents in the request.
    - `height` (integer, required) — Size of the field in pixels.
    - `required` (boolean, required) — Whether this field is required.
    - `signer` (string, required) — Signer index identified by the offset in the signers parameter (0-based indexing), indicating which signer should fill out the field. **NOTE:** To set the value of the field as the preparer you must set this to `me_now` **NOTE:** If type is `text-merge` or `checkbox-merge`, you must set this to sender in order to use pre-filled data.
    - `width` (integer, required) — Size of the field in pixels.
    - `x` (integer, required) — Location coordinates of the field in pixels.
    - `y` (integer, required) — Location coordinates of the field in pixels.
    - `name` (string, optional) — Display name for the field.
    - `page` (integer, optional, nullable) — Page in the document where the field should be placed (requires documents be PDF files). - When the page number parameter is supplied, the API will use the new coordinate system. - Check out the differences between both [coordinate systems](https://faq.hellosign.com/hc/en-us/articles/217115577) and how to use them.
  - `type`: `text-merge` (text-merge)
    - `document_index` (integer, required) — Represents the integer index of the `file` or `file_url` document the field should be attached to.
    - `api_id` (string, required) — An identifier for the field that is unique across all documents in the request.
    - `height` (integer, required) — Size of the field in pixels.
    - `required` (boolean, required) — Whether this field is required.
    - `signer` (string, required) — Signer index identified by the offset in the signers parameter (0-based indexing), indicating which signer should fill out the field. **NOTE:** To set the value of the field as the preparer you must set this to `me_now` **NOTE:** If type is `text-merge` or `checkbox-merge`, you must set this to sender in order to use pre-filled data.
    - `width` (integer, required) — Size of the field in pixels.
    - `x` (integer, required) — Location coordinates of the field in pixels.
    - `y` (integer, required) — Location coordinates of the field in pixels.
    - `name` (string, optional) — Display name for the field.
    - `page` (integer, optional, nullable) — Page in the document where the field should be placed (requires documents be PDF files). - When the page number parameter is supplied, the API will use the new coordinate system. - Check out the differences between both [coordinate systems](https://faq.hellosign.com/hc/en-us/articles/217115577) and how to use them.
  - `type`: `checkbox-merge` (checkbox-merge)
    - `document_index` (integer, required) — Represents the integer index of the `file` or `file_url` document the field should be attached to.
    - `api_id` (string, required) — An identifier for the field that is unique across all documents in the request.
    - `height` (integer, required) — Size of the field in pixels.
    - `required` (boolean, required) — Whether this field is required.
    - `signer` (string, required) — Signer index identified by the offset in the signers parameter (0-based indexing), indicating which signer should fill out the field. **NOTE:** To set the value of the field as the preparer you must set this to `me_now` **NOTE:** If type is `text-merge` or `checkbox-merge`, you must set this to sender in order to use pre-filled data.
    - `width` (integer, required) — Size of the field in pixels.
    - `x` (integer, required) — Location coordinates of the field in pixels.
    - `y` (integer, required) — Location coordinates of the field in pixels.
    - `name` (string, optional) — Display name for the field.
    - `page` (integer, optional, nullable) — Page in the document where the field should be placed (requires documents be PDF files). - When the page number parameter is supplied, the API will use the new coordinate system. - Check out the differences between both [coordinate systems](https://faq.hellosign.com/hc/en-us/articles/217115577) and how to use them.
- `hide_text_tags` (boolean, optional, default: false) — Enables automatic Text Tag removal when set to true. **NOTE:** Removing text tags this way can cause unwanted clipping. We recommend leaving this setting on `false` and instead hiding your text tags using white text or a similar approach. See the [Text Tags Walkthrough](https://app.hellosign.com/api/textTagsWalkthrough#TextTagIntro) for more information.
- `is_eid` (boolean, optional, default: false) — Send with a value of `true` if you wish to enable [electronic identification (eID)](https://sign.dropbox.com/features/electronic-id), which requires the signer to verify their identity with an eID provider to sign a document. **NOTE:** You need the eID add-on to use this feature. Please [contact sales](https://sign.dropbox.com/form/contact-sales) for more information. Cannot be used in `test_mode`. Only works on requests with one signer.
- `message` (string, optional) — The custom message in the email that will be sent to the signers.
- `metadata` (map from string to any, optional) — Key-value data that should be attached to the signature request. This metadata is included in all API responses and events involving the signature request. For example, use the metadata field to store a signer's order number for look up when receiving events for the signature request. Each request can include up to 10 metadata keys (or 50 nested metadata keys), with key names up to 40 characters long and values up to 1000 characters long.
- `signing_options` (object, optional) — This allows the requester to specify the types allowed for creating a signature and specify another signing options. **NOTE:** If `signing_options` are not defined in the request, the allowed types will default to those specified in the account settings. **NOTE:** If `force_advanced_signature_details` is set, allowed types has to be defined too.
  - `default_type` (enum, required) — The default type shown (limited to the listed types)
    - Allowed values: `draw`, `phone`, `type`, `upload`
  - `draw` (boolean, optional, default: false) — Allows drawing the signature
  - `phone` (boolean, optional, default: false) — Allows using a smartphone to email the signature
  - `type` (boolean, optional, default: false) — Allows typing the signature
  - `upload` (boolean, optional, default: false) — Allows uploading the signature
  - `force_advanced_signature_details` (boolean, optional, default: false) — Turning on advanced signature details for the signature request
- `signing_redirect_url` (string, optional) — The URL you want signers redirected to after they successfully sign.
- `subject` (string, optional) — The subject in the email that will be sent to the signers.
- `test_mode` (boolean, optional, default: false) — Whether this is a test, the signature request will not be legally binding if set to `true`. Defaults to `false`.
- `title` (string, optional) — The title you want to assign to the SignatureRequest.
- `use_text_tags` (boolean, optional, default: false) — Send with a value of `true` if you wish to enable [Text Tags](https://app.hellosign.com/api/textTagsWalkthrough#TextTagIntro) parsing in your document. Defaults to disabled, or `false`.
- `expires_at` (integer, optional, nullable) — When the signature request will expire. Unsigned signatures will be moved to the expired status, and no longer signable. See [Signature Request Expiration Date](https://developers.hellosign.com/docs/signature-request/expiration/) for details.

## Response

### 200

successful operation

- `signature_request` (object, required) — Contains information about a signature request.
  - `test_mode` (boolean, optional, default: false) — Whether this is a test signature request. Test requests have no legal value. Defaults to `false`.
  - `signature_request_id` (string, optional) — The id of the SignatureRequest.
  - `requester_email_address` (string, optional, nullable) — The email address of the initiator of the SignatureRequest.
  - `title` (string, optional) — The title the specified Account uses for the SignatureRequest.
  - `original_title` (string, optional) — Default Label for account.
  - `subject` (string, optional, nullable) — The subject in the email that was initially sent to the signers.
  - `message` (string, optional, nullable) — The custom message in the email that was initially sent to the signers.
  - `metadata` (map from string to any, optional) — The metadata attached to the signature request.
  - `created_at` (integer, optional) — Time the signature request was created.
  - `expires_at` (integer, optional, nullable) — The time when the signature request will expire unsigned signatures. See [Signature Request Expiration Date](https://developers.hellosign.com/docs/signature-request/expiration/) for details.
  - `is_complete` (boolean, optional) — Whether or not the SignatureRequest has been fully executed by all signers.
  - `is_declined` (boolean, optional) — Whether or not the SignatureRequest has been declined by a signer.
  - `has_error` (boolean, optional) — Whether or not an error occurred (either during the creation of the SignatureRequest or during one of the signings).
  - `files_url` (string, optional) — The URL where a copy of the request's documents can be downloaded.
  - `signing_url` (string, optional, nullable) — The URL where a signer, after authenticating, can sign the documents. This should only be used by users with existing Dropbox Sign accounts as they will be required to log in before signing.
  - `details_url` (string, optional) — The URL where the requester and the signers can view the current status of the SignatureRequest.
  - `cc_email_addresses` (list of string, optional) — A list of email addresses that were CCed on the SignatureRequest. They will receive a copy of the final PDF once all the signers have signed.
  - `signing_redirect_url` (string, optional, nullable) — The URL you want the signer redirected to after they successfully sign.
  - `final_copy_uri` (string, optional, nullable) — The path where the completed document can be downloaded
  - `template_ids` (list of string, optional, nullable) — Templates IDs used in this SignatureRequest (if any).
  - `custom_fields` (list of object, optional, nullable) — An array of Custom Field objects containing the name and type of each custom field. * Text Field uses `SignatureRequestResponseCustomFieldText` * Checkbox Field uses `SignatureRequestResponseCustomFieldCheckbox`
    - `type`: `text` (text)
      - `name` (string, required) — The name of the Custom Field.
      - `api_id` (string, optional) — The unique ID for this field.
      - `editor` (string, optional, nullable) — The name of the Role that is able to edit this field.
      - `required` (boolean, optional) — A boolean value denoting if this field is required.
      - `value` (string, optional) — A text string for text fields
    - `type`: `checkbox` (checkbox)
      - `name` (string, required) — The name of the Custom Field.
      - `api_id` (string, optional) — The unique ID for this field.
      - `editor` (string, optional, nullable) — The name of the Role that is able to edit this field.
      - `required` (boolean, optional) — A boolean value denoting if this field is required.
      - `value` (boolean, optional) — A true/false for checkbox fields
  - `attachments` (list of object, optional, nullable) — Signer attachments.
    - `id` (string, required) — The unique ID for this attachment.
    - `signer` (string, required) — The Signer this attachment is assigned to.
    - `name` (string, required) — The name of this attachment.
    - `required` (boolean, required) — A boolean value denoting if this attachment is required.
    - `instructions` (string, optional, nullable) — Instructions for Signer.
    - `uploaded_at` (integer, optional, nullable) — Timestamp when attachment was uploaded by Signer.
  - `response_data` (list of object, optional, nullable) — An array of form field objects containing the name, value, and type of each textbox or checkmark field filled in by the signers.
    - `type`: `text` (text)
      - `api_id` (string, optional) — The unique ID for this field.
      - `signature_id` (string, optional) — The ID of the signature to which this response is linked.
      - `name` (string, optional) — The name of the form field.
      - `required` (boolean, optional) — A boolean value denoting if this field is required.
    - `type`: `checkbox` (checkbox)
      - `api_id` (string, optional) — The unique ID for this field.
      - `signature_id` (string, optional) — The ID of the signature to which this response is linked.
      - `name` (string, optional) — The name of the form field.
      - `required` (boolean, optional) — A boolean value denoting if this field is required.
    - `type`: `dropdown` (dropdown)
      - `api_id` (string, optional) — The unique ID for this field.
      - `signature_id` (string, optional) — The ID of the signature to which this response is linked.
      - `name` (string, optional) — The name of the form field.
      - `required` (boolean, optional) — A boolean value denoting if this field is required.
    - `type`: `radio` (radio)
      - `api_id` (string, optional) — The unique ID for this field.
      - `signature_id` (string, optional) — The ID of the signature to which this response is linked.
      - `name` (string, optional) — The name of the form field.
      - `required` (boolean, optional) — A boolean value denoting if this field is required.
    - `type`: `signature` (signature)
      - `api_id` (string, optional) — The unique ID for this field.
      - `signature_id` (string, optional) — The ID of the signature to which this response is linked.
      - `name` (string, optional) — The name of the form field.
      - `required` (boolean, optional) — A boolean value denoting if this field is required.
    - `type`: `date_signed` (date_signed)
      - `api_id` (string, optional) — The unique ID for this field.
      - `signature_id` (string, optional) — The ID of the signature to which this response is linked.
      - `name` (string, optional) — The name of the form field.
      - `required` (boolean, optional) — A boolean value denoting if this field is required.
    - `type`: `initials` (initials)
      - `api_id` (string, optional) — The unique ID for this field.
      - `signature_id` (string, optional) — The ID of the signature to which this response is linked.
      - `name` (string, optional) — The name of the form field.
      - `required` (boolean, optional) — A boolean value denoting if this field is required.
    - `type`: `text-merge` (text-merge)
      - `api_id` (string, optional) — The unique ID for this field.
      - `signature_id` (string, optional) — The ID of the signature to which this response is linked.
      - `name` (string, optional) — The name of the form field.
      - `required` (boolean, optional) — A boolean value denoting if this field is required.
    - `type`: `checkbox-merge` (checkbox-merge)
      - `api_id` (string, optional) — The unique ID for this field.
      - `signature_id` (string, optional) — The ID of the signature to which this response is linked.
      - `name` (string, optional) — The name of the form field.
      - `required` (boolean, optional) — A boolean value denoting if this field is required.
  - `signatures` (list of object, optional) — An array of signature objects, 1 for each signer.
    - `signature_id` (string, optional) — Signature identifier.
    - `signer_group_guid` (string, optional, nullable) — Signer Group GUID
    - `signer_email_address` (string, optional) — The email address of the signer.
    - `signer_name` (string, optional, nullable) — The name of the signer.
    - `signer_role` (string, optional, nullable) — The role of the signer.
    - `order` (integer, optional, nullable) — If signer order is assigned this is the 0-based index for this signer.
    - `status_code` (string, optional) — The current status of the signature. eg: awaiting_signature, signed, declined.
    - `decline_reason` (string, optional, nullable) — The reason provided by the signer for declining the request.
    - `signed_at` (integer, optional, nullable) — Time that the document was signed or null.
    - `last_viewed_at` (integer, optional, nullable) — The time that the document was last viewed by this signer or null.
    - `last_reminded_at` (integer, optional, nullable) — The time the last reminder email was sent to the signer or null.
    - `has_pin` (boolean, optional) — Boolean to indicate whether this signature requires a PIN to access.
    - `has_sms_auth` (boolean, optional, nullable) — Boolean to indicate whether this signature has SMS authentication enabled.
    - `has_sms_delivery` (boolean, optional, nullable) — Boolean to indicate whether this signature has SMS delivery enabled.
    - `sms_phone_number` (string, optional, nullable) — The SMS phone number used for authentication or signature request delivery.
    - `reassigned_by` (string, optional, nullable) — Email address of original signer who reassigned to this signer.
    - `reassignment_reason` (string, optional, nullable) — Reason provided by original signer who reassigned to this signer.
    - `reassigned_from` (string, optional, nullable) — Previous signature identifier.
    - `error` (string, optional, nullable) — Error message pertaining to this signer, or null.
  - `bulk_send_job_id` (string, optional, nullable) — The ID of the Bulk Send job which sent the signature request, if applicable.
- `warnings` (list of object, optional) — A list of warnings.
  - `warning_msg` (string, required) — Warning message
  - `warning_name` (string, required) — Warning name

## Examples

### Send Signature Request

**Request**

```json
undefined
```

**Response**

```json
{
  "signature_request": {
    "test_mode": true,
    "signature_request_id": "2b388914e3ae3b738bd4e2ee2850c677e6dc53d2",
    "requester_email_address": "me@dropboxsign.com",
    "title": "NDA with Acme Co.",
    "original_title": "The NDA we talked about",
    "subject": "The NDA we talked about",
    "message": "Please sign this NDA and then we can discuss more. Let me know if you have any questions.",
    "metadata": {
      "custom_id": "1234",
      "custom_text": "NDA #9"
    },
    "created_at": 1570471067,
    "is_complete": false,
    "is_declined": false,
    "has_error": false,
    "files_url": "https://api.hellosign.com/v3/signature_request/files/2b388914e3ae3b738bd4e2ee2850c677e6dc53d2",
    "signing_url": "https://app.hellosign.com/sign/2b388914e3ae3b738bd4e2ee2850c677e6dc53d2",
    "details_url": "https://app.hellosign.com/home/manage?guid=2b388914e3ae3b738bd4e2ee2850c677e6dc53d2",
    "cc_email_addresses": [
      "lawyer1@dropboxsign.com",
      "lawyer2@example.com"
    ],
    "signing_redirect_url": null,
    "template_ids": null,
    "custom_fields": [],
    "attachments": [
      {
        "id": "id_1",
        "signer": "1",
        "name": "Attachment #1",
        "required": true,
        "instructions": "Instructions #1",
        "uploaded_at": 1650398513
      },
      {
        "id": "id_2",
        "signer": "2",
        "name": "Attachment #2",
        "required": true,
        "instructions": null,
        "uploaded_at": null
      }
    ],
    "response_data": [],
    "signatures": [
      {
        "signature_id": "78caf2a1d01cd39cea2bc1cbb340dac3",
        "signer_email_address": "jack@example.com",
        "signer_name": "Jack",
        "signer_role": null,
        "order": 0,
        "status_code": "awaiting_signature",
        "signed_at": null,
        "last_viewed_at": null,
        "last_reminded_at": null,
        "has_pin": false,
        "has_sms_auth": false
      },
      {
        "signature_id": "616629ed37f8588d28600be17ab5d6b7",
        "signer_email_address": "jill@example.com",
        "signer_name": "Jill",
        "signer_role": null,
        "order": 1,
        "status_code": "awaiting_signature",
        "signed_at": null,
        "last_viewed_at": null,
        "last_reminded_at": null,
        "has_pin": false,
        "has_sms_auth": false
      }
    ]
  }
}
```

**SDK Code**

```php PHP
<?php

namespace Dropbox\SignSandbox;

require_once __DIR__ . '/../vendor/autoload.php';

use SplFileObject;
use Dropbox;

$config = Dropbox\Sign\Configuration::getDefaultConfiguration();
$config->setUsername("YOUR_API_KEY");
// $config->setAccessToken("YOUR_ACCESS_TOKEN");

$field_options = (new Dropbox\Sign\Model\SubFieldOptions())
    ->setDateFormat(Dropbox\Sign\Model\SubFieldOptions::DATE_FORMAT_DD_MM_YYYY);

$signing_options = (new Dropbox\Sign\Model\SubSigningOptions())
    ->setDefaultType(Dropbox\Sign\Model\SubSigningOptions::DEFAULT_TYPE_DRAW)
    ->setDraw(true)
    ->setPhone(false)
    ->setType(true)
    ->setUpload(true);

$signers_1 = (new Dropbox\Sign\Model\SubSignatureRequestSigner())
    ->setName("Jack")
    ->setEmailAddress("jack@example.com")
    ->setOrder(0);

$signers_2 = (new Dropbox\Sign\Model\SubSignatureRequestSigner())
    ->setName("Jill")
    ->setEmailAddress("jill@example.com")
    ->setOrder(1);

$signers = [
    $signers_1,
    $signers_2,
];

$signature_request_edit_request = (new Dropbox\Sign\Model\SignatureRequestEditRequest())
    ->setMessage("Please sign this NDA and then we can discuss more. Let me know if you\nhave any questions.")
    ->setSubject("The NDA we talked about")
    ->setTestMode(true)
    ->setTitle("NDA with Acme Co.")
    ->setCcEmailAddresses([
        "lawyer1@dropboxsign.com",
        "lawyer2@dropboxsign.com",
    ])
    ->setFiles([
    ])
    ->setMetadata(json_decode(<<<'EOD'
        {
            "custom_id": 1234,
            "custom_text": "NDA #9"
        }
    EOD, true))
    ->setFieldOptions($field_options)
    ->setSigningOptions($signing_options)
    ->setSigners($signers);

try {
    $response = (new Dropbox\Sign\Api\SignatureRequestApi(config: $config))->signatureRequestEdit(
        signature_request_id: "fa5c8a0b0f492d768749333ad6fcc214c111e967",
        signature_request_edit_request: $signature_request_edit_request,
    );

    print_r($response);
} catch (Dropbox\Sign\ApiException $e) {
    echo "Exception when calling SignatureRequestApi#signatureRequestEdit: {$e->getMessage()}";
}

```

```csharp C#
using System;
using System.Collections.Generic;
using System.IO;
using System.Text.Json;

using Dropbox.Sign.Api;
using Dropbox.Sign.Client;
using Dropbox.Sign.Model;

namespace Dropbox.SignSandbox;

public class SignatureRequestEditExample
{
    public static void Run()
    {
        var config = new Configuration();
        config.Username = "YOUR_API_KEY";
        // config.AccessToken = "YOUR_ACCESS_TOKEN";

        var fieldOptions = new SubFieldOptions(
            dateFormat: SubFieldOptions.DateFormatEnum.DD_MM_YYYY
        );

        var signingOptions = new SubSigningOptions(
            defaultType: SubSigningOptions.DefaultTypeEnum.Draw,
            draw: true,
            phone: false,
            type: true,
            upload: true
        );

        var signers1 = new SubSignatureRequestSigner(
            name: "Jack",
            emailAddress: "jack@example.com",
            order: 0
        );

        var signers2 = new SubSignatureRequestSigner(
            name: "Jill",
            emailAddress: "jill@example.com",
            order: 1
        );

        var signers = new List<SubSignatureRequestSigner>
        {
            signers1,
            signers2,
        };

        var signatureRequestEditRequest = new SignatureRequestEditRequest(
            message: "Please sign this NDA and then we can discuss more. Let me know if you\nhave any questions.",
            subject: "The NDA we talked about",
            testMode: true,
            title: "NDA with Acme Co.",
            ccEmailAddresses: [
                "lawyer1@dropboxsign.com",
                "lawyer2@dropboxsign.com",
            ],
            files: new List<Stream>
            {
                new FileStream(
                    path: "./example_signature_request.pdf",
                    mode: FileMode.Open
                ),
            },
            metadata: JsonSerializer.Deserialize<Dictionary<string, object>>("""
                {
                    "custom_id": 1234,
                    "custom_text": "NDA #9"
                }
            """),
            fieldOptions: fieldOptions,
            signingOptions: signingOptions,
            signers: signers
        );

        try
        {
            var response = new SignatureRequestApi(config).SignatureRequestEdit(
                signatureRequestId: "fa5c8a0b0f492d768749333ad6fcc214c111e967",
                signatureRequestEditRequest: signatureRequestEditRequest
            );

            Console.WriteLine(response);
        }
        catch (ApiException e)
        {
            Console.WriteLine("Exception when calling SignatureRequestApi#SignatureRequestEdit: " + e.Message);
            Console.WriteLine("Status Code: " + e.ErrorCode);
            Console.WriteLine(e.StackTrace);
        }
    }
}

```

```typescript TypeScript
import * as fs from 'fs';
import api from "@dropbox/sign"
import models from "@dropbox/sign"

const apiCaller = new api.SignatureRequestApi();
apiCaller.username = "YOUR_API_KEY";
// apiCaller.accessToken = "YOUR_ACCESS_TOKEN";

const fieldOptions: models.SubFieldOptions = {
  dateFormat: models.SubFieldOptions.DateFormatEnum.DdMmYyyy,
};

const signingOptions: models.SubSigningOptions = {
  defaultType: models.SubSigningOptions.DefaultTypeEnum.Draw,
  draw: true,
  phone: false,
  type: true,
  upload: true,
};

const signers1: models.SubSignatureRequestSigner = {
  name: "Jack",
  emailAddress: "jack@example.com",
  order: 0,
};

const signers2: models.SubSignatureRequestSigner = {
  name: "Jill",
  emailAddress: "jill@example.com",
  order: 1,
};

const signers = [
  signers1,
  signers2,
];

const signatureRequestEditRequest: models.SignatureRequestEditRequest = {
  message: "Please sign this NDA and then we can discuss more. Let me know if you\nhave any questions.",
  subject: "The NDA we talked about",
  testMode: true,
  title: "NDA with Acme Co.",
  ccEmailAddresses: [
    "lawyer1@dropboxsign.com",
    "lawyer2@dropboxsign.com",
  ],
  files: [
    fs.createReadStream("./example_signature_request.pdf"),
  ],
  metadata: {
    "custom_id": 1234,
    "custom_text": "NDA #9"
  },
  fieldOptions: fieldOptions,
  signingOptions: signingOptions,
  signers: signers,
};

apiCaller.signatureRequestEdit(
  "fa5c8a0b0f492d768749333ad6fcc214c111e967", // signatureRequestId
  signatureRequestEditRequest,
).then(response => {
  console.log(response.body);
}).catch(error => {
  console.log("Exception when calling SignatureRequestApi#signatureRequestEdit:");
  console.log(error.body);
});

```

```java Java
package com.dropbox.sign_sandbox;

import com.dropbox.sign.ApiException;
import com.dropbox.sign.Configuration;
import com.dropbox.sign.api.*;
import com.dropbox.sign.auth.*;
import com.dropbox.sign.JSON;
import com.dropbox.sign.model.*;

import java.io.File;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.OffsetDateTime;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class SignatureRequestEditExample
{
    public static void main(String[] args)
    {
        var config = Configuration.getDefaultApiClient();
        ((HttpBasicAuth) config.getAuthentication("api_key")).setUsername("YOUR_API_KEY");
        // ((HttpBearerAuth) config.getAuthentication("oauth2")).setBearerToken("YOUR_ACCESS_TOKEN");

        var fieldOptions = new SubFieldOptions();
        fieldOptions.dateFormat(SubFieldOptions.DateFormatEnum.DD_MM_YYYY);

        var signingOptions = new SubSigningOptions();
        signingOptions.defaultType(SubSigningOptions.DefaultTypeEnum.DRAW);
        signingOptions.draw(true);
        signingOptions.phone(false);
        signingOptions.type(true);
        signingOptions.upload(true);

        var signers1 = new SubSignatureRequestSigner();
        signers1.name("Jack");
        signers1.emailAddress("jack@example.com");
        signers1.order(0);

        var signers2 = new SubSignatureRequestSigner();
        signers2.name("Jill");
        signers2.emailAddress("jill@example.com");
        signers2.order(1);

        var signers = new ArrayList<SubSignatureRequestSigner>(List.of (
            signers1,
            signers2
        ));

        var signatureRequestEditRequest = new SignatureRequestEditRequest();
        signatureRequestEditRequest.message("Please sign this NDA and then we can discuss more. Let me know if you\nhave any questions.");
        signatureRequestEditRequest.subject("The NDA we talked about");
        signatureRequestEditRequest.testMode(true);
        signatureRequestEditRequest.title("NDA with Acme Co.");
        signatureRequestEditRequest.ccEmailAddresses(List.of (
            "lawyer1@dropboxsign.com",
            "lawyer2@dropboxsign.com"
        ));
        signatureRequestEditRequest.files(List.of (
            new File("./example_signature_request.pdf")
        ));
        signatureRequestEditRequest.metadata(JSON.deserialize("""
            {
                "custom_id": 1234,
                "custom_text": "NDA #9"
            }
        """, Map.class));
        signatureRequestEditRequest.fieldOptions(fieldOptions);
        signatureRequestEditRequest.signingOptions(signingOptions);
        signatureRequestEditRequest.signers(signers);

        try
        {
            var response = new SignatureRequestApi(config).signatureRequestEdit(
                "fa5c8a0b0f492d768749333ad6fcc214c111e967", // signatureRequestId
                signatureRequestEditRequest
            );

            System.out.println(response);
        } catch (ApiException e) {
            System.err.println("Exception when calling SignatureRequestApi#signatureRequestEdit");
            System.err.println("Status code: " + e.getCode());
            System.err.println("Reason: " + e.getResponseBody());
            System.err.println("Response headers: " + e.getResponseHeaders());
            e.printStackTrace();
        }
    }
}

```

```ruby Ruby
require "json"
require "dropbox-sign"

Dropbox::Sign.configure do |config|
    config.username = "YOUR_API_KEY"
    # config.access_token = "YOUR_ACCESS_TOKEN"
end

field_options = Dropbox::Sign::SubFieldOptions.new
field_options.date_format = "DD - MM - YYYY"

signing_options = Dropbox::Sign::SubSigningOptions.new
signing_options.default_type = "draw"
signing_options.draw = true
signing_options.phone = false
signing_options.type = true
signing_options.upload = true

signers_1 = Dropbox::Sign::SubSignatureRequestSigner.new
signers_1.name = "Jack"
signers_1.email_address = "jack@example.com"
signers_1.order = 0

signers_2 = Dropbox::Sign::SubSignatureRequestSigner.new
signers_2.name = "Jill"
signers_2.email_address = "jill@example.com"
signers_2.order = 1

signers = [
    signers_1,
    signers_2,
]

signature_request_edit_request = Dropbox::Sign::SignatureRequestEditRequest.new
signature_request_edit_request.message = "Please sign this NDA and then we can discuss more. Let me know if you\nhave any questions."
signature_request_edit_request.subject = "The NDA we talked about"
signature_request_edit_request.test_mode = true
signature_request_edit_request.title = "NDA with Acme Co."
signature_request_edit_request.cc_email_addresses = [
    "lawyer1@dropboxsign.com",
    "lawyer2@dropboxsign.com",
]
signature_request_edit_request.files = [
    File.new("./example_signature_request.pdf", "r"),
]
signature_request_edit_request.metadata = JSON.parse(<<-EOD
    {
        "custom_id": 1234,
        "custom_text": "NDA #9"
    }
    EOD
)
signature_request_edit_request.field_options = field_options
signature_request_edit_request.signing_options = signing_options
signature_request_edit_request.signers = signers

begin
    response = Dropbox::Sign::SignatureRequestApi.new.signature_request_edit(
        "fa5c8a0b0f492d768749333ad6fcc214c111e967", # signature_request_id
        signature_request_edit_request,
    )

    p response
rescue Dropbox::Sign::ApiError => e
    puts "Exception when calling SignatureRequestApi#signature_request_edit: #{e}"
end

```

```python Python
import json
from datetime import date, datetime
from pprint import pprint

from dropbox_sign import ApiClient, ApiException, Configuration, api, models

configuration = Configuration(
    username="YOUR_API_KEY",
    # access_token="YOUR_ACCESS_TOKEN",
)

with ApiClient(configuration) as api_client:
    field_options = models.SubFieldOptions(
        date_format="DD - MM - YYYY",
    )

    signing_options = models.SubSigningOptions(
        default_type="draw",
        draw=True,
        phone=False,
        type=True,
        upload=True,
    )

    signers_1 = models.SubSignatureRequestSigner(
        name="Jack",
        email_address="jack@example.com",
        order=0,
    )

    signers_2 = models.SubSignatureRequestSigner(
        name="Jill",
        email_address="jill@example.com",
        order=1,
    )

    signers = [
        signers_1,
        signers_2,
    ]

    signature_request_edit_request = models.SignatureRequestEditRequest(
        message="Please sign this NDA and then we can discuss more. Let me know if you\nhave any questions.",
        subject="The NDA we talked about",
        test_mode=True,
        title="NDA with Acme Co.",
        cc_email_addresses=[
            "lawyer1@dropboxsign.com",
            "lawyer2@dropboxsign.com",
        ],
        files=[
            open("./example_signature_request.pdf", "rb").read(),
        ],
        metadata=json.loads("""
            {
                "custom_id": 1234,
                "custom_text": "NDA #9"
            }
        """),
        field_options=field_options,
        signing_options=signing_options,
        signers=signers,
    )

    try:
        response = api.SignatureRequestApi(api_client).signature_request_edit(
            signature_request_id="fa5c8a0b0f492d768749333ad6fcc214c111e967",
            signature_request_edit_request=signature_request_edit_request,
        )

        pprint(response)
    except ApiException as e:
        print("Exception when calling SignatureRequestApi#signature_request_edit: %s\n" % e)

```

```go Send Signature Request
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.hellosign.com/v3/signature_request/edit/fa5c8a0b0f492d768749333ad6fcc214c111e967"

	req, _ := http.NewRequest("PUT", url, nil)

	req.SetBasicAuth("<apiKey>", "")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```swift Send Signature Request
import Foundation

let credentials = Data("<apiKey>:".utf8).base64EncodedString()

let headers = [
  "Authorization": "Basic \(credentials)",
  "Content-Type": "application/json"
]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.hellosign.com/v3/signature_request/edit/fa5c8a0b0f492d768749333ad6fcc214c111e967")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

### Default Example

**Request**

```json
{
  "file_urls": [
    "https://www.dropbox.com/s/ad9qnhbrjjn64tu/mutual-NDA-example.pdf?dl=1"
  ],
  "signers": [
    {
      "name": "Jack",
      "email_address": "jack@example.com",
      "order": 0
    },
    {
      "name": "Jill",
      "email_address": "jill@example.com",
      "order": 1
    }
  ],
  "cc_email_addresses": [
    "lawyer1@dropboxsign.com",
    "lawyer2@dropboxsign.com"
  ],
  "field_options": {
    "date_format": "DD - MM - YYYY"
  },
  "message": "Please sign this NDA and then we can discuss more. Let me know if you\nhave any questions.",
  "metadata": {
    "custom_id": 1234,
    "custom_text": "NDA #9"
  },
  "signing_options": {
    "default_type": "draw",
    "draw": true,
    "phone": false,
    "type": true,
    "upload": true
  },
  "subject": "The NDA we talked about",
  "test_mode": true,
  "title": "NDA with Acme Co."
}
```

**Response**

```json
{
  "signature_request": {
    "test_mode": true,
    "signature_request_id": "2b388914e3ae3b738bd4e2ee2850c677e6dc53d2",
    "requester_email_address": "me@dropboxsign.com",
    "title": "NDA with Acme Co.",
    "original_title": "The NDA we talked about",
    "subject": "The NDA we talked about",
    "message": "Please sign this NDA and then we can discuss more. Let me know if you have any questions.",
    "metadata": {
      "custom_id": "1234",
      "custom_text": "NDA #9"
    },
    "created_at": 1570471067,
    "is_complete": false,
    "is_declined": false,
    "has_error": false,
    "files_url": "https://api.hellosign.com/v3/signature_request/files/2b388914e3ae3b738bd4e2ee2850c677e6dc53d2",
    "signing_url": "https://app.hellosign.com/sign/2b388914e3ae3b738bd4e2ee2850c677e6dc53d2",
    "details_url": "https://app.hellosign.com/home/manage?guid=2b388914e3ae3b738bd4e2ee2850c677e6dc53d2",
    "cc_email_addresses": [
      "lawyer1@dropboxsign.com",
      "lawyer2@example.com"
    ],
    "signing_redirect_url": null,
    "template_ids": null,
    "custom_fields": [],
    "attachments": [
      {
        "id": "id_1",
        "signer": "1",
        "name": "Attachment #1",
        "required": true,
        "instructions": "Instructions #1",
        "uploaded_at": 1650398513
      },
      {
        "id": "id_2",
        "signer": "2",
        "name": "Attachment #2",
        "required": true,
        "instructions": null,
        "uploaded_at": null
      }
    ],
    "response_data": [],
    "signatures": [
      {
        "signature_id": "78caf2a1d01cd39cea2bc1cbb340dac3",
        "signer_email_address": "jack@example.com",
        "signer_name": "Jack",
        "signer_role": null,
        "order": 0,
        "status_code": "awaiting_signature",
        "signed_at": null,
        "last_viewed_at": null,
        "last_reminded_at": null,
        "has_pin": false,
        "has_sms_auth": false
      },
      {
        "signature_id": "616629ed37f8588d28600be17ab5d6b7",
        "signer_email_address": "jill@example.com",
        "signer_name": "Jill",
        "signer_role": null,
        "order": 1,
        "status_code": "awaiting_signature",
        "signed_at": null,
        "last_viewed_at": null,
        "last_reminded_at": null,
        "has_pin": false,
        "has_sms_auth": false
      }
    ]
  }
}
```

**SDK Code**

```php PHP
<?php

namespace Dropbox\SignSandbox;

require_once __DIR__ . '/../vendor/autoload.php';

use SplFileObject;
use Dropbox;

$config = Dropbox\Sign\Configuration::getDefaultConfiguration();
$config->setUsername("YOUR_API_KEY");
// $config->setAccessToken("YOUR_ACCESS_TOKEN");

$field_options = (new Dropbox\Sign\Model\SubFieldOptions())
    ->setDateFormat(Dropbox\Sign\Model\SubFieldOptions::DATE_FORMAT_DD_MM_YYYY);

$signing_options = (new Dropbox\Sign\Model\SubSigningOptions())
    ->setDefaultType(Dropbox\Sign\Model\SubSigningOptions::DEFAULT_TYPE_DRAW)
    ->setDraw(true)
    ->setPhone(false)
    ->setType(true)
    ->setUpload(true);

$signers_1 = (new Dropbox\Sign\Model\SubSignatureRequestSigner())
    ->setName("Jack")
    ->setEmailAddress("jack@example.com")
    ->setOrder(0);

$signers_2 = (new Dropbox\Sign\Model\SubSignatureRequestSigner())
    ->setName("Jill")
    ->setEmailAddress("jill@example.com")
    ->setOrder(1);

$signers = [
    $signers_1,
    $signers_2,
];

$signature_request_edit_request = (new Dropbox\Sign\Model\SignatureRequestEditRequest())
    ->setMessage("Please sign this NDA and then we can discuss more. Let me know if you\nhave any questions.")
    ->setSubject("The NDA we talked about")
    ->setTestMode(true)
    ->setTitle("NDA with Acme Co.")
    ->setCcEmailAddresses([
        "lawyer1@dropboxsign.com",
        "lawyer2@dropboxsign.com",
    ])
    ->setFiles([
    ])
    ->setMetadata(json_decode(<<<'EOD'
        {
            "custom_id": 1234,
            "custom_text": "NDA #9"
        }
    EOD, true))
    ->setFieldOptions($field_options)
    ->setSigningOptions($signing_options)
    ->setSigners($signers);

try {
    $response = (new Dropbox\Sign\Api\SignatureRequestApi(config: $config))->signatureRequestEdit(
        signature_request_id: "fa5c8a0b0f492d768749333ad6fcc214c111e967",
        signature_request_edit_request: $signature_request_edit_request,
    );

    print_r($response);
} catch (Dropbox\Sign\ApiException $e) {
    echo "Exception when calling SignatureRequestApi#signatureRequestEdit: {$e->getMessage()}";
}

```

```csharp C#
using System;
using System.Collections.Generic;
using System.IO;
using System.Text.Json;

using Dropbox.Sign.Api;
using Dropbox.Sign.Client;
using Dropbox.Sign.Model;

namespace Dropbox.SignSandbox;

public class SignatureRequestEditExample
{
    public static void Run()
    {
        var config = new Configuration();
        config.Username = "YOUR_API_KEY";
        // config.AccessToken = "YOUR_ACCESS_TOKEN";

        var fieldOptions = new SubFieldOptions(
            dateFormat: SubFieldOptions.DateFormatEnum.DD_MM_YYYY
        );

        var signingOptions = new SubSigningOptions(
            defaultType: SubSigningOptions.DefaultTypeEnum.Draw,
            draw: true,
            phone: false,
            type: true,
            upload: true
        );

        var signers1 = new SubSignatureRequestSigner(
            name: "Jack",
            emailAddress: "jack@example.com",
            order: 0
        );

        var signers2 = new SubSignatureRequestSigner(
            name: "Jill",
            emailAddress: "jill@example.com",
            order: 1
        );

        var signers = new List<SubSignatureRequestSigner>
        {
            signers1,
            signers2,
        };

        var signatureRequestEditRequest = new SignatureRequestEditRequest(
            message: "Please sign this NDA and then we can discuss more. Let me know if you\nhave any questions.",
            subject: "The NDA we talked about",
            testMode: true,
            title: "NDA with Acme Co.",
            ccEmailAddresses: [
                "lawyer1@dropboxsign.com",
                "lawyer2@dropboxsign.com",
            ],
            files: new List<Stream>
            {
                new FileStream(
                    path: "./example_signature_request.pdf",
                    mode: FileMode.Open
                ),
            },
            metadata: JsonSerializer.Deserialize<Dictionary<string, object>>("""
                {
                    "custom_id": 1234,
                    "custom_text": "NDA #9"
                }
            """),
            fieldOptions: fieldOptions,
            signingOptions: signingOptions,
            signers: signers
        );

        try
        {
            var response = new SignatureRequestApi(config).SignatureRequestEdit(
                signatureRequestId: "fa5c8a0b0f492d768749333ad6fcc214c111e967",
                signatureRequestEditRequest: signatureRequestEditRequest
            );

            Console.WriteLine(response);
        }
        catch (ApiException e)
        {
            Console.WriteLine("Exception when calling SignatureRequestApi#SignatureRequestEdit: " + e.Message);
            Console.WriteLine("Status Code: " + e.ErrorCode);
            Console.WriteLine(e.StackTrace);
        }
    }
}

```

```typescript TypeScript
import * as fs from 'fs';
import api from "@dropbox/sign"
import models from "@dropbox/sign"

const apiCaller = new api.SignatureRequestApi();
apiCaller.username = "YOUR_API_KEY";
// apiCaller.accessToken = "YOUR_ACCESS_TOKEN";

const fieldOptions: models.SubFieldOptions = {
  dateFormat: models.SubFieldOptions.DateFormatEnum.DdMmYyyy,
};

const signingOptions: models.SubSigningOptions = {
  defaultType: models.SubSigningOptions.DefaultTypeEnum.Draw,
  draw: true,
  phone: false,
  type: true,
  upload: true,
};

const signers1: models.SubSignatureRequestSigner = {
  name: "Jack",
  emailAddress: "jack@example.com",
  order: 0,
};

const signers2: models.SubSignatureRequestSigner = {
  name: "Jill",
  emailAddress: "jill@example.com",
  order: 1,
};

const signers = [
  signers1,
  signers2,
];

const signatureRequestEditRequest: models.SignatureRequestEditRequest = {
  message: "Please sign this NDA and then we can discuss more. Let me know if you\nhave any questions.",
  subject: "The NDA we talked about",
  testMode: true,
  title: "NDA with Acme Co.",
  ccEmailAddresses: [
    "lawyer1@dropboxsign.com",
    "lawyer2@dropboxsign.com",
  ],
  files: [
    fs.createReadStream("./example_signature_request.pdf"),
  ],
  metadata: {
    "custom_id": 1234,
    "custom_text": "NDA #9"
  },
  fieldOptions: fieldOptions,
  signingOptions: signingOptions,
  signers: signers,
};

apiCaller.signatureRequestEdit(
  "fa5c8a0b0f492d768749333ad6fcc214c111e967", // signatureRequestId
  signatureRequestEditRequest,
).then(response => {
  console.log(response.body);
}).catch(error => {
  console.log("Exception when calling SignatureRequestApi#signatureRequestEdit:");
  console.log(error.body);
});

```

```java Java
package com.dropbox.sign_sandbox;

import com.dropbox.sign.ApiException;
import com.dropbox.sign.Configuration;
import com.dropbox.sign.api.*;
import com.dropbox.sign.auth.*;
import com.dropbox.sign.JSON;
import com.dropbox.sign.model.*;

import java.io.File;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.OffsetDateTime;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class SignatureRequestEditExample
{
    public static void main(String[] args)
    {
        var config = Configuration.getDefaultApiClient();
        ((HttpBasicAuth) config.getAuthentication("api_key")).setUsername("YOUR_API_KEY");
        // ((HttpBearerAuth) config.getAuthentication("oauth2")).setBearerToken("YOUR_ACCESS_TOKEN");

        var fieldOptions = new SubFieldOptions();
        fieldOptions.dateFormat(SubFieldOptions.DateFormatEnum.DD_MM_YYYY);

        var signingOptions = new SubSigningOptions();
        signingOptions.defaultType(SubSigningOptions.DefaultTypeEnum.DRAW);
        signingOptions.draw(true);
        signingOptions.phone(false);
        signingOptions.type(true);
        signingOptions.upload(true);

        var signers1 = new SubSignatureRequestSigner();
        signers1.name("Jack");
        signers1.emailAddress("jack@example.com");
        signers1.order(0);

        var signers2 = new SubSignatureRequestSigner();
        signers2.name("Jill");
        signers2.emailAddress("jill@example.com");
        signers2.order(1);

        var signers = new ArrayList<SubSignatureRequestSigner>(List.of (
            signers1,
            signers2
        ));

        var signatureRequestEditRequest = new SignatureRequestEditRequest();
        signatureRequestEditRequest.message("Please sign this NDA and then we can discuss more. Let me know if you\nhave any questions.");
        signatureRequestEditRequest.subject("The NDA we talked about");
        signatureRequestEditRequest.testMode(true);
        signatureRequestEditRequest.title("NDA with Acme Co.");
        signatureRequestEditRequest.ccEmailAddresses(List.of (
            "lawyer1@dropboxsign.com",
            "lawyer2@dropboxsign.com"
        ));
        signatureRequestEditRequest.files(List.of (
            new File("./example_signature_request.pdf")
        ));
        signatureRequestEditRequest.metadata(JSON.deserialize("""
            {
                "custom_id": 1234,
                "custom_text": "NDA #9"
            }
        """, Map.class));
        signatureRequestEditRequest.fieldOptions(fieldOptions);
        signatureRequestEditRequest.signingOptions(signingOptions);
        signatureRequestEditRequest.signers(signers);

        try
        {
            var response = new SignatureRequestApi(config).signatureRequestEdit(
                "fa5c8a0b0f492d768749333ad6fcc214c111e967", // signatureRequestId
                signatureRequestEditRequest
            );

            System.out.println(response);
        } catch (ApiException e) {
            System.err.println("Exception when calling SignatureRequestApi#signatureRequestEdit");
            System.err.println("Status code: " + e.getCode());
            System.err.println("Reason: " + e.getResponseBody());
            System.err.println("Response headers: " + e.getResponseHeaders());
            e.printStackTrace();
        }
    }
}

```

```ruby Ruby
require "json"
require "dropbox-sign"

Dropbox::Sign.configure do |config|
    config.username = "YOUR_API_KEY"
    # config.access_token = "YOUR_ACCESS_TOKEN"
end

field_options = Dropbox::Sign::SubFieldOptions.new
field_options.date_format = "DD - MM - YYYY"

signing_options = Dropbox::Sign::SubSigningOptions.new
signing_options.default_type = "draw"
signing_options.draw = true
signing_options.phone = false
signing_options.type = true
signing_options.upload = true

signers_1 = Dropbox::Sign::SubSignatureRequestSigner.new
signers_1.name = "Jack"
signers_1.email_address = "jack@example.com"
signers_1.order = 0

signers_2 = Dropbox::Sign::SubSignatureRequestSigner.new
signers_2.name = "Jill"
signers_2.email_address = "jill@example.com"
signers_2.order = 1

signers = [
    signers_1,
    signers_2,
]

signature_request_edit_request = Dropbox::Sign::SignatureRequestEditRequest.new
signature_request_edit_request.message = "Please sign this NDA and then we can discuss more. Let me know if you\nhave any questions."
signature_request_edit_request.subject = "The NDA we talked about"
signature_request_edit_request.test_mode = true
signature_request_edit_request.title = "NDA with Acme Co."
signature_request_edit_request.cc_email_addresses = [
    "lawyer1@dropboxsign.com",
    "lawyer2@dropboxsign.com",
]
signature_request_edit_request.files = [
    File.new("./example_signature_request.pdf", "r"),
]
signature_request_edit_request.metadata = JSON.parse(<<-EOD
    {
        "custom_id": 1234,
        "custom_text": "NDA #9"
    }
    EOD
)
signature_request_edit_request.field_options = field_options
signature_request_edit_request.signing_options = signing_options
signature_request_edit_request.signers = signers

begin
    response = Dropbox::Sign::SignatureRequestApi.new.signature_request_edit(
        "fa5c8a0b0f492d768749333ad6fcc214c111e967", # signature_request_id
        signature_request_edit_request,
    )

    p response
rescue Dropbox::Sign::ApiError => e
    puts "Exception when calling SignatureRequestApi#signature_request_edit: #{e}"
end

```

```python Python
import json
from datetime import date, datetime
from pprint import pprint

from dropbox_sign import ApiClient, ApiException, Configuration, api, models

configuration = Configuration(
    username="YOUR_API_KEY",
    # access_token="YOUR_ACCESS_TOKEN",
)

with ApiClient(configuration) as api_client:
    field_options = models.SubFieldOptions(
        date_format="DD - MM - YYYY",
    )

    signing_options = models.SubSigningOptions(
        default_type="draw",
        draw=True,
        phone=False,
        type=True,
        upload=True,
    )

    signers_1 = models.SubSignatureRequestSigner(
        name="Jack",
        email_address="jack@example.com",
        order=0,
    )

    signers_2 = models.SubSignatureRequestSigner(
        name="Jill",
        email_address="jill@example.com",
        order=1,
    )

    signers = [
        signers_1,
        signers_2,
    ]

    signature_request_edit_request = models.SignatureRequestEditRequest(
        message="Please sign this NDA and then we can discuss more. Let me know if you\nhave any questions.",
        subject="The NDA we talked about",
        test_mode=True,
        title="NDA with Acme Co.",
        cc_email_addresses=[
            "lawyer1@dropboxsign.com",
            "lawyer2@dropboxsign.com",
        ],
        files=[
            open("./example_signature_request.pdf", "rb").read(),
        ],
        metadata=json.loads("""
            {
                "custom_id": 1234,
                "custom_text": "NDA #9"
            }
        """),
        field_options=field_options,
        signing_options=signing_options,
        signers=signers,
    )

    try:
        response = api.SignatureRequestApi(api_client).signature_request_edit(
            signature_request_id="fa5c8a0b0f492d768749333ad6fcc214c111e967",
            signature_request_edit_request=signature_request_edit_request,
        )

        pprint(response)
    except ApiException as e:
        print("Exception when calling SignatureRequestApi#signature_request_edit: %s\n" % e)

```

```go Default Example
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.hellosign.com/v3/signature_request/edit/fa5c8a0b0f492d768749333ad6fcc214c111e967"

	payload := strings.NewReader("{\n  \"file_urls\": [\n    \"https://www.dropbox.com/s/ad9qnhbrjjn64tu/mutual-NDA-example.pdf?dl=1\"\n  ],\n  \"signers\": [\n    {\n      \"name\": \"Jack\",\n      \"email_address\": \"jack@example.com\",\n      \"order\": 0\n    },\n    {\n      \"name\": \"Jill\",\n      \"email_address\": \"jill@example.com\",\n      \"order\": 1\n    }\n  ],\n  \"cc_email_addresses\": [\n    \"lawyer1@dropboxsign.com\",\n    \"lawyer2@dropboxsign.com\"\n  ],\n  \"field_options\": {\n    \"date_format\": \"DD - MM - YYYY\"\n  },\n  \"message\": \"Please sign this NDA and then we can discuss more. Let me know if you\\nhave any questions.\",\n  \"metadata\": {\n    \"custom_id\": 1234,\n    \"custom_text\": \"NDA #9\"\n  },\n  \"signing_options\": {\n    \"default_type\": \"draw\",\n    \"draw\": true,\n    \"phone\": false,\n    \"type\": true,\n    \"upload\": true\n  },\n  \"subject\": \"The NDA we talked about\",\n  \"test_mode\": true,\n  \"title\": \"NDA with Acme Co.\"\n}")

	req, _ := http.NewRequest("PUT", url, payload)

	req.SetBasicAuth("<apiKey>", "")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```swift Default Example
import Foundation

let credentials = Data("<apiKey>:".utf8).base64EncodedString()

let headers = [
  "Authorization": "Basic \(credentials)",
  "Content-Type": "application/json"
]
let parameters = [
  "file_urls": ["https://www.dropbox.com/s/ad9qnhbrjjn64tu/mutual-NDA-example.pdf?dl=1"],
  "signers": [
    [
      "name": "Jack",
      "email_address": "jack@example.com",
      "order": 0
    ],
    [
      "name": "Jill",
      "email_address": "jill@example.com",
      "order": 1
    ]
  ],
  "cc_email_addresses": ["lawyer1@dropboxsign.com", "lawyer2@dropboxsign.com"],
  "field_options": ["date_format": "DD - MM - YYYY"],
  "message": "Please sign this NDA and then we can discuss more. Let me know if you
have any questions.",
  "metadata": [
    "custom_id": 1234,
    "custom_text": "NDA #9"
  ],
  "signing_options": [
    "default_type": "draw",
    "draw": true,
    "phone": false,
    "type": true,
    "upload": true
  ],
  "subject": "The NDA we talked about",
  "test_mode": true,
  "title": "NDA with Acme Co."
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.hellosign.com/v3/signature_request/edit/fa5c8a0b0f492d768749333ad6fcc214c111e967")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

### Grouped Signers Example

**Request**

```json
{
  "file_urls": [
    "https://www.dropbox.com/s/ad9qnhbrjjn64tu/mutual-NDA-example.pdf?dl=1"
  ],
  "grouped_signers": [
    {
      "group": "Group #1",
      "signers": [
        {
          "name": "Jack",
          "email_address": "jack@example.com"
        },
        {
          "name": "Jill",
          "email_address": "jill@example.com"
        }
      ],
      "order": 0
    },
    {
      "group": "Group #2",
      "signers": [
        {
          "name": "Bob",
          "email_address": "bob@example.com"
        },
        {
          "name": "Charlie",
          "email_address": "charlie@example.com"
        }
      ],
      "order": 1
    }
  ],
  "cc_email_addresses": [
    "lawyer1@dropboxsign.com",
    "lawyer2@dropboxsign.com"
  ],
  "field_options": {
    "date_format": "DD - MM - YYYY"
  },
  "message": "Please sign this NDA and then we can discuss more. Let me know if you\nhave any questions.",
  "metadata": {
    "custom_id": 1234,
    "custom_text": "NDA #9"
  },
  "signing_options": {
    "default_type": "draw",
    "draw": true,
    "phone": false,
    "type": true,
    "upload": true
  },
  "subject": "The NDA we talked about",
  "test_mode": true,
  "title": "NDA with Acme Co."
}
```

**Response**

```json
{
  "signature_request": {
    "test_mode": true,
    "signature_request_id": "2b388914e3ae3b738bd4e2ee2850c677e6dc53d2",
    "requester_email_address": "me@dropboxsign.com",
    "title": "NDA with Acme Co.",
    "original_title": "The NDA we talked about",
    "subject": "The NDA we talked about",
    "message": "Please sign this NDA and then we can discuss more. Let me know if you have any questions.",
    "metadata": {
      "custom_id": "1234",
      "custom_text": "NDA #9"
    },
    "created_at": 1570471067,
    "is_complete": false,
    "is_declined": false,
    "has_error": false,
    "files_url": "https://api.hellosign.com/v3/signature_request/files/2b388914e3ae3b738bd4e2ee2850c677e6dc53d2",
    "signing_url": "https://app.hellosign.com/sign/2b388914e3ae3b738bd4e2ee2850c677e6dc53d2",
    "details_url": "https://app.hellosign.com/home/manage?guid=2b388914e3ae3b738bd4e2ee2850c677e6dc53d2",
    "cc_email_addresses": [
      "lawyer1@dropboxsign.com",
      "lawyer2@example.com"
    ],
    "signing_redirect_url": null,
    "template_ids": null,
    "custom_fields": [],
    "attachments": [
      {
        "id": "id_1",
        "signer": "1",
        "name": "Attachment #1",
        "required": true,
        "instructions": "Instructions #1",
        "uploaded_at": 1650398513
      },
      {
        "id": "id_2",
        "signer": "2",
        "name": "Attachment #2",
        "required": true,
        "instructions": null,
        "uploaded_at": null
      }
    ],
    "response_data": [],
    "signatures": [
      {
        "signature_id": "78caf2a1d01cd39cea2bc1cbb340dac3",
        "signer_email_address": "jack@example.com",
        "signer_name": "Jack",
        "signer_role": null,
        "order": 0,
        "status_code": "awaiting_signature",
        "signed_at": null,
        "last_viewed_at": null,
        "last_reminded_at": null,
        "has_pin": false,
        "has_sms_auth": false
      },
      {
        "signature_id": "616629ed37f8588d28600be17ab5d6b7",
        "signer_email_address": "jill@example.com",
        "signer_name": "Jill",
        "signer_role": null,
        "order": 1,
        "status_code": "awaiting_signature",
        "signed_at": null,
        "last_viewed_at": null,
        "last_reminded_at": null,
        "has_pin": false,
        "has_sms_auth": false
      }
    ]
  }
}
```

**SDK Code**

```php PHP
<?php

namespace Dropbox\SignSandbox;

require_once __DIR__ . '/../vendor/autoload.php';

use SplFileObject;
use Dropbox;

$config = Dropbox\Sign\Configuration::getDefaultConfiguration();
$config->setUsername("YOUR_API_KEY");
// $config->setAccessToken("YOUR_ACCESS_TOKEN");

$field_options = (new Dropbox\Sign\Model\SubFieldOptions())
    ->setDateFormat(Dropbox\Sign\Model\SubFieldOptions::DATE_FORMAT_DD_MM_YYYY);

$signing_options = (new Dropbox\Sign\Model\SubSigningOptions())
    ->setDefaultType(Dropbox\Sign\Model\SubSigningOptions::DEFAULT_TYPE_DRAW)
    ->setDraw(true)
    ->setPhone(false)
    ->setType(true)
    ->setUpload(true);

$signers_1 = (new Dropbox\Sign\Model\SubSignatureRequestSigner())
    ->setName("Jack")
    ->setEmailAddress("jack@example.com")
    ->setOrder(0);

$signers_2 = (new Dropbox\Sign\Model\SubSignatureRequestSigner())
    ->setName("Jill")
    ->setEmailAddress("jill@example.com")
    ->setOrder(1);

$signers = [
    $signers_1,
    $signers_2,
];

$signature_request_edit_request = (new Dropbox\Sign\Model\SignatureRequestEditRequest())
    ->setMessage("Please sign this NDA and then we can discuss more. Let me know if you\nhave any questions.")
    ->setSubject("The NDA we talked about")
    ->setTestMode(true)
    ->setTitle("NDA with Acme Co.")
    ->setCcEmailAddresses([
        "lawyer1@dropboxsign.com",
        "lawyer2@dropboxsign.com",
    ])
    ->setFiles([
    ])
    ->setMetadata(json_decode(<<<'EOD'
        {
            "custom_id": 1234,
            "custom_text": "NDA #9"
        }
    EOD, true))
    ->setFieldOptions($field_options)
    ->setSigningOptions($signing_options)
    ->setSigners($signers);

try {
    $response = (new Dropbox\Sign\Api\SignatureRequestApi(config: $config))->signatureRequestEdit(
        signature_request_id: "fa5c8a0b0f492d768749333ad6fcc214c111e967",
        signature_request_edit_request: $signature_request_edit_request,
    );

    print_r($response);
} catch (Dropbox\Sign\ApiException $e) {
    echo "Exception when calling SignatureRequestApi#signatureRequestEdit: {$e->getMessage()}";
}

```

```csharp C#
using System;
using System.Collections.Generic;
using System.IO;
using System.Text.Json;

using Dropbox.Sign.Api;
using Dropbox.Sign.Client;
using Dropbox.Sign.Model;

namespace Dropbox.SignSandbox;

public class SignatureRequestEditExample
{
    public static void Run()
    {
        var config = new Configuration();
        config.Username = "YOUR_API_KEY";
        // config.AccessToken = "YOUR_ACCESS_TOKEN";

        var fieldOptions = new SubFieldOptions(
            dateFormat: SubFieldOptions.DateFormatEnum.DD_MM_YYYY
        );

        var signingOptions = new SubSigningOptions(
            defaultType: SubSigningOptions.DefaultTypeEnum.Draw,
            draw: true,
            phone: false,
            type: true,
            upload: true
        );

        var signers1 = new SubSignatureRequestSigner(
            name: "Jack",
            emailAddress: "jack@example.com",
            order: 0
        );

        var signers2 = new SubSignatureRequestSigner(
            name: "Jill",
            emailAddress: "jill@example.com",
            order: 1
        );

        var signers = new List<SubSignatureRequestSigner>
        {
            signers1,
            signers2,
        };

        var signatureRequestEditRequest = new SignatureRequestEditRequest(
            message: "Please sign this NDA and then we can discuss more. Let me know if you\nhave any questions.",
            subject: "The NDA we talked about",
            testMode: true,
            title: "NDA with Acme Co.",
            ccEmailAddresses: [
                "lawyer1@dropboxsign.com",
                "lawyer2@dropboxsign.com",
            ],
            files: new List<Stream>
            {
                new FileStream(
                    path: "./example_signature_request.pdf",
                    mode: FileMode.Open
                ),
            },
            metadata: JsonSerializer.Deserialize<Dictionary<string, object>>("""
                {
                    "custom_id": 1234,
                    "custom_text": "NDA #9"
                }
            """),
            fieldOptions: fieldOptions,
            signingOptions: signingOptions,
            signers: signers
        );

        try
        {
            var response = new SignatureRequestApi(config).SignatureRequestEdit(
                signatureRequestId: "fa5c8a0b0f492d768749333ad6fcc214c111e967",
                signatureRequestEditRequest: signatureRequestEditRequest
            );

            Console.WriteLine(response);
        }
        catch (ApiException e)
        {
            Console.WriteLine("Exception when calling SignatureRequestApi#SignatureRequestEdit: " + e.Message);
            Console.WriteLine("Status Code: " + e.ErrorCode);
            Console.WriteLine(e.StackTrace);
        }
    }
}

```

```typescript TypeScript
import * as fs from 'fs';
import api from "@dropbox/sign"
import models from "@dropbox/sign"

const apiCaller = new api.SignatureRequestApi();
apiCaller.username = "YOUR_API_KEY";
// apiCaller.accessToken = "YOUR_ACCESS_TOKEN";

const fieldOptions: models.SubFieldOptions = {
  dateFormat: models.SubFieldOptions.DateFormatEnum.DdMmYyyy,
};

const signingOptions: models.SubSigningOptions = {
  defaultType: models.SubSigningOptions.DefaultTypeEnum.Draw,
  draw: true,
  phone: false,
  type: true,
  upload: true,
};

const signers1: models.SubSignatureRequestSigner = {
  name: "Jack",
  emailAddress: "jack@example.com",
  order: 0,
};

const signers2: models.SubSignatureRequestSigner = {
  name: "Jill",
  emailAddress: "jill@example.com",
  order: 1,
};

const signers = [
  signers1,
  signers2,
];

const signatureRequestEditRequest: models.SignatureRequestEditRequest = {
  message: "Please sign this NDA and then we can discuss more. Let me know if you\nhave any questions.",
  subject: "The NDA we talked about",
  testMode: true,
  title: "NDA with Acme Co.",
  ccEmailAddresses: [
    "lawyer1@dropboxsign.com",
    "lawyer2@dropboxsign.com",
  ],
  files: [
    fs.createReadStream("./example_signature_request.pdf"),
  ],
  metadata: {
    "custom_id": 1234,
    "custom_text": "NDA #9"
  },
  fieldOptions: fieldOptions,
  signingOptions: signingOptions,
  signers: signers,
};

apiCaller.signatureRequestEdit(
  "fa5c8a0b0f492d768749333ad6fcc214c111e967", // signatureRequestId
  signatureRequestEditRequest,
).then(response => {
  console.log(response.body);
}).catch(error => {
  console.log("Exception when calling SignatureRequestApi#signatureRequestEdit:");
  console.log(error.body);
});

```

```java Java
package com.dropbox.sign_sandbox;

import com.dropbox.sign.ApiException;
import com.dropbox.sign.Configuration;
import com.dropbox.sign.api.*;
import com.dropbox.sign.auth.*;
import com.dropbox.sign.JSON;
import com.dropbox.sign.model.*;

import java.io.File;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.OffsetDateTime;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class SignatureRequestEditExample
{
    public static void main(String[] args)
    {
        var config = Configuration.getDefaultApiClient();
        ((HttpBasicAuth) config.getAuthentication("api_key")).setUsername("YOUR_API_KEY");
        // ((HttpBearerAuth) config.getAuthentication("oauth2")).setBearerToken("YOUR_ACCESS_TOKEN");

        var fieldOptions = new SubFieldOptions();
        fieldOptions.dateFormat(SubFieldOptions.DateFormatEnum.DD_MM_YYYY);

        var signingOptions = new SubSigningOptions();
        signingOptions.defaultType(SubSigningOptions.DefaultTypeEnum.DRAW);
        signingOptions.draw(true);
        signingOptions.phone(false);
        signingOptions.type(true);
        signingOptions.upload(true);

        var signers1 = new SubSignatureRequestSigner();
        signers1.name("Jack");
        signers1.emailAddress("jack@example.com");
        signers1.order(0);

        var signers2 = new SubSignatureRequestSigner();
        signers2.name("Jill");
        signers2.emailAddress("jill@example.com");
        signers2.order(1);

        var signers = new ArrayList<SubSignatureRequestSigner>(List.of (
            signers1,
            signers2
        ));

        var signatureRequestEditRequest = new SignatureRequestEditRequest();
        signatureRequestEditRequest.message("Please sign this NDA and then we can discuss more. Let me know if you\nhave any questions.");
        signatureRequestEditRequest.subject("The NDA we talked about");
        signatureRequestEditRequest.testMode(true);
        signatureRequestEditRequest.title("NDA with Acme Co.");
        signatureRequestEditRequest.ccEmailAddresses(List.of (
            "lawyer1@dropboxsign.com",
            "lawyer2@dropboxsign.com"
        ));
        signatureRequestEditRequest.files(List.of (
            new File("./example_signature_request.pdf")
        ));
        signatureRequestEditRequest.metadata(JSON.deserialize("""
            {
                "custom_id": 1234,
                "custom_text": "NDA #9"
            }
        """, Map.class));
        signatureRequestEditRequest.fieldOptions(fieldOptions);
        signatureRequestEditRequest.signingOptions(signingOptions);
        signatureRequestEditRequest.signers(signers);

        try
        {
            var response = new SignatureRequestApi(config).signatureRequestEdit(
                "fa5c8a0b0f492d768749333ad6fcc214c111e967", // signatureRequestId
                signatureRequestEditRequest
            );

            System.out.println(response);
        } catch (ApiException e) {
            System.err.println("Exception when calling SignatureRequestApi#signatureRequestEdit");
            System.err.println("Status code: " + e.getCode());
            System.err.println("Reason: " + e.getResponseBody());
            System.err.println("Response headers: " + e.getResponseHeaders());
            e.printStackTrace();
        }
    }
}

```

```ruby Ruby
require "json"
require "dropbox-sign"

Dropbox::Sign.configure do |config|
    config.username = "YOUR_API_KEY"
    # config.access_token = "YOUR_ACCESS_TOKEN"
end

field_options = Dropbox::Sign::SubFieldOptions.new
field_options.date_format = "DD - MM - YYYY"

signing_options = Dropbox::Sign::SubSigningOptions.new
signing_options.default_type = "draw"
signing_options.draw = true
signing_options.phone = false
signing_options.type = true
signing_options.upload = true

signers_1 = Dropbox::Sign::SubSignatureRequestSigner.new
signers_1.name = "Jack"
signers_1.email_address = "jack@example.com"
signers_1.order = 0

signers_2 = Dropbox::Sign::SubSignatureRequestSigner.new
signers_2.name = "Jill"
signers_2.email_address = "jill@example.com"
signers_2.order = 1

signers = [
    signers_1,
    signers_2,
]

signature_request_edit_request = Dropbox::Sign::SignatureRequestEditRequest.new
signature_request_edit_request.message = "Please sign this NDA and then we can discuss more. Let me know if you\nhave any questions."
signature_request_edit_request.subject = "The NDA we talked about"
signature_request_edit_request.test_mode = true
signature_request_edit_request.title = "NDA with Acme Co."
signature_request_edit_request.cc_email_addresses = [
    "lawyer1@dropboxsign.com",
    "lawyer2@dropboxsign.com",
]
signature_request_edit_request.files = [
    File.new("./example_signature_request.pdf", "r"),
]
signature_request_edit_request.metadata = JSON.parse(<<-EOD
    {
        "custom_id": 1234,
        "custom_text": "NDA #9"
    }
    EOD
)
signature_request_edit_request.field_options = field_options
signature_request_edit_request.signing_options = signing_options
signature_request_edit_request.signers = signers

begin
    response = Dropbox::Sign::SignatureRequestApi.new.signature_request_edit(
        "fa5c8a0b0f492d768749333ad6fcc214c111e967", # signature_request_id
        signature_request_edit_request,
    )

    p response
rescue Dropbox::Sign::ApiError => e
    puts "Exception when calling SignatureRequestApi#signature_request_edit: #{e}"
end

```

```python Python
import json
from datetime import date, datetime
from pprint import pprint

from dropbox_sign import ApiClient, ApiException, Configuration, api, models

configuration = Configuration(
    username="YOUR_API_KEY",
    # access_token="YOUR_ACCESS_TOKEN",
)

with ApiClient(configuration) as api_client:
    field_options = models.SubFieldOptions(
        date_format="DD - MM - YYYY",
    )

    signing_options = models.SubSigningOptions(
        default_type="draw",
        draw=True,
        phone=False,
        type=True,
        upload=True,
    )

    signers_1 = models.SubSignatureRequestSigner(
        name="Jack",
        email_address="jack@example.com",
        order=0,
    )

    signers_2 = models.SubSignatureRequestSigner(
        name="Jill",
        email_address="jill@example.com",
        order=1,
    )

    signers = [
        signers_1,
        signers_2,
    ]

    signature_request_edit_request = models.SignatureRequestEditRequest(
        message="Please sign this NDA and then we can discuss more. Let me know if you\nhave any questions.",
        subject="The NDA we talked about",
        test_mode=True,
        title="NDA with Acme Co.",
        cc_email_addresses=[
            "lawyer1@dropboxsign.com",
            "lawyer2@dropboxsign.com",
        ],
        files=[
            open("./example_signature_request.pdf", "rb").read(),
        ],
        metadata=json.loads("""
            {
                "custom_id": 1234,
                "custom_text": "NDA #9"
            }
        """),
        field_options=field_options,
        signing_options=signing_options,
        signers=signers,
    )

    try:
        response = api.SignatureRequestApi(api_client).signature_request_edit(
            signature_request_id="fa5c8a0b0f492d768749333ad6fcc214c111e967",
            signature_request_edit_request=signature_request_edit_request,
        )

        pprint(response)
    except ApiException as e:
        print("Exception when calling SignatureRequestApi#signature_request_edit: %s\n" % e)

```

```go Grouped Signers Example
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.hellosign.com/v3/signature_request/edit/fa5c8a0b0f492d768749333ad6fcc214c111e967"

[...]
